// (C) 2001-2010 Altera Corporation. All rights reserved.
// Your use of Altera Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Altera Program License Subscription 
// Agreement, Altera MegaCore Function License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Altera and sold by 
// Altera or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


module sv_10gbaser_ch #(
	parameter operation_mode = "duplex",
	parameter output_clock_frequency = "10312.5 Mbps",
	parameter ref_clk_freq = "322.265625 Mhz"
)(
//	input  wire     tx_pll_clk, //clk from tx_pll
	input  wire     pll_ref_clk,         //      pll_ref_clk.clk
	input  wire     xgmii_tx_clk,        //     xgmii_tx_clk.clk
	input  wire     xgmii_rx_clk,        //     xgmii_tx_clk.clk
	input  wire     tx_digital_rstn,
	input  wire     tx_analog_rst,
	input  wire     rx_digital_rstn,
	input  wire     rx_analog_rstn,
	input  wire     pll_rstn,
	input  wire 	[71:0] xgmii_tx_dc,      //    xgmii_tx_dc_0.data
	output wire 	[71:0] xgmii_rx_dc,      //    xgmii_rx_dc_0.data
	output wire     tx_serial_data, // tx_serial_data_0.export
	input  wire     rx_serial_data,  // rx_serial_data_0.export
	output wire     rx_is_lockedtodata,          //        rx_ready0.data
	output wire     rx_is_lockedtoref,          //        rx_ready0.data
	output wire     pll_locked,          //        rx_ready0.data

	input  wire  	rxclrerrorblockcount,
	input  wire  	rxclrbercount,
	input  wire  	rxprbserrorclr,
	output wire 	pcsstatus,
	output wire 	rxblocklock,
	output wire 	rxhighber,
	output wire 	[ 5:0 ] bercount,
	output wire 	[ 7:0 ] errorblockcount,
	output wire 	[ 15:0 ] randomerrorcount,
	output wire 	rxfifoempty,
	output wire 	rxfifopartialempty,
	output wire 	rxfifopartialfull,
	output wire 	rxfifofull,
	output wire 	rxsyncheadererror,
	output wire 	rxscramblererror,

	output wire 	txfifoempty,
	output wire 	txfifopartialempty,
	output wire 	txfifopartialfull,
	output wire 	txfifofull
);
wire clkout_totx ;

generate 
	if ( operation_mode != "tx_only")
	begin
		sv_10gbaser_rx_ch #(
			.output_clock_frequency(output_clock_frequency),
			.ref_clk_freq (ref_clk_freq)
		)sv_10gbaser_rx_ch_0(
			.rx_digital_rstn(rx_digital_rstn),
			.rx_analog_rstn(rx_analog_rstn),
			.xgmii_tx_clk(xgmii_tx_clk),        //     xgmii_tx_clk.clk
			.pll_ref_clk(pll_ref_clk),         //      pll_ref_clk.clk
			.rx_is_lockedtodata(rx_is_lockedtodata),          //        rx_ready0.data
			.rx_is_lockedtoref(rx_is_lockedtoref),          //        rx_ready0.data
			.xgmii_rx_dc(xgmii_rx_dc),      //    xgmii_rx_dc_0.data
			.rx_serial_data(rx_serial_data),  // rx_serial_data_0.export
			.rxclrerrorblockcount(rxclrerrorblockcount),
			.rxclrbercount(rxclrbercount),
			.rxprbserrorclr(rxprbserrorclr),
			.pcsstatus(pcsstatus),
			.rxblocklock(rxblocklock),
			.rxhighber(rxhighber),
			.bercount(bercount),
			.errorblockcount(errorblockcount),
			.randomerrorcount(randomerrorcount),
			.rxfifoempty(rxfifoempty),
			.rxfifopartialempty(rxfifopartialempty),
			.rxfifopartialfull(rxfifopartialfull),
			.rxfifofull(rxfifofull),
			.rxsyncheadererror(rxsyncheadererror),
			.rxscramblererror(rxscramblererror)
		);   
	 end   
endgenerate

generate 
	if ( operation_mode != "rx_only")
	begin
	sv_10gbaser_tx_ch sv_10gbaser_tx_ch_0(
	.tx_pll_clk(clkout_totx),
	.tx_digital_rstn(tx_digital_rstn),
	.tx_analog_rst(tx_analog_rst),
	.xgmii_tx_clk(xgmii_tx_clk),        //     xgmii_tx_clk.clk
	.xgmii_tx_dc(xgmii_tx_dc),      //    xgmii_tx_dc_0.data
	.tx_serial_data(tx_serial_data), // tx_serial_data_0.export
	.txfifoempty(txfifoempty),
	.txfifopartialempty(txfifopartialempty),
	.txfifopartialfull(txfifopartialfull),
	.txfifofull(txfifofull)
	);  
	end    
endgenerate


tx_10g_pll#(
	.input_clock_frequency(ref_clk_freq),
	.output_clock_frequency0(output_clock_frequency),
	.output_clock_frequency1("156.25 MHz")
)tx_pll(
	.pll_rstn(pll_rstn),
	.pll_ref_clk(pll_ref_clk),         
	.pll_locked(pll_locked),           
	.clkout_totx(clkout_totx),       
	.clk33pcs(xgmii_rx_clk)      

);


endmodule                                                               