// (C) 2001-2010 Altera Corporation. All rights reserved.
// Your use of Altera Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Altera Program License Subscription 
// Agreement, Altera MegaCore Function License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Altera and sold by 
// Altera or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


module sv_10gbaser_tx_ch #(
	parameter output_clock_frequency = "10312.5 Mbps"
	) (
	input  wire        tx_pll_clk,
	input  wire        tx_digital_rstn,
	input  wire        tx_analog_rst,
	input  wire        xgmii_tx_clk,        //     xgmii_tx_clk.clk
	input  wire 	[71 :0] xgmii_tx_dc,      //    xgmii_tx_dc_0.data
	output wire        tx_serial_data, // tx_serial_data_0.export
	output wire 		txfifoempty,
	output wire 		txfifopartialempty,
	output wire 		txfifopartialfull,
	output wire 		txfifofull
);

wire [39:0] tx_parallel_data;
wire tx_pll_is_locked;
wire clk_from_tx_pma;
wire [ 63:0 ] tx_datain;  
wire [ 7:0 ] tx_control;   
wire  rx_data_valid;	
generate
genvar i;
for (i=0; i<8; i=i+1) 
begin: bus_assign
	assign tx_datain[8*(i+1) -1 : 8*i] = xgmii_tx_dc[9*(i+1)-2 : 9*i];
	assign tx_control[i] = xgmii_tx_dc[9*(i+1)-1];
end 
endgenerate
       
sv_tx_pma #(
	.bonded_lanes ( 1),
	.bonding_master_ch_num ( 0),
   	.data_rate (output_clock_frequency),
	.mode (40),
	.channel_number ( 0),
	.auto_negotiation ( "false"),
	.pclksel ( "local_pclk"),
	.ht_delay_sel ( "false")
) sv_tx_pma_0( 
	//input port for buf
	.datain(tx_parallel_data),
	
	//output port for buf
	.dataout(tx_serial_data),

	//input ports for ser
	.rstn(tx_analog_rst),
	
	//output ports for ser
//	output	[bonded_lanes - 1 :	0] clkdivtx,  

	// NOTE: this signal is driven by the master channel. 
    // NOTE: Thus it can either be one of the data channels or a master-only channel.
	.master_clkdivtx(clk_from_tx_pma), 

	//input ports for cgb
	.clk (tx_pll_clk)
);

sv_tx_10g_pcs #(
	.pma_pcs_width (40), 			//Valid values: 0..65, all the lanes are bonded
	.pld_pcs_width (64), 			//Valid values: 0..65, all the lanes are bonded

	.prot_mode ("teng_baser_mode"),		//Valid values: "disable_mode"|"teng_baser_mode"|"interlaken_mode"|SFIS_MODE|TENG_SDI_MODE|basic_mode|"test_prbs_mode"|"test_prp_mode"
	//tx_fifo
	.txfifo_mode ("phase_comp"),	//Valid values: PHASE_COMP|CLK_COMP|"register_mode"|GENERIC

	.enc_64b66b_txsm_bypass_ena ("false"),	//true, false	
	.enc_tx_sm_bypass_en ("false"),	//true, false	//Valid values: TX_SM_BYPASS_DIS|TX_SM_BYPASS_EN

	.test_mode ("test_off")			//Valid values: TEST_OFF|PSEUDO_RANDOM|SQ_WAVE|PRBS_31|PRBS_23|PRBS_9|PRBS_7
)sv_tx_10g_pcs_0 (//input and output port declaration
	.clockinfrompma(clk_from_tx_pma),
	.txpldrstn(tx_digital_rstn),
	.txdatavalid(1'b1),
	.tx_datain(tx_datain),
	.tx_control({1'b0,tx_control}),
	
	.dataout_to_pma(tx_parallel_data),
	.txclkiqout(),
	.txfifoempty(txfifoempty),
	.txfifopartialempty(txfifopartialempty),
	.txfifopartialfull(txfifopartialfull),
	.txfifofull(txfifofull)
);

endmodule
