// (C) 2001-2010 Altera Corporation. All rights reserved.
// Your use of Altera Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Altera Program License Subscription 
// Agreement, Altera MegaCore Function License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Altera and sold by 
// Altera or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


// megafunction wizard: %Altera PLL v10.0%
// GENERATION: XML
`timescale 1ns/10ps

module tx_10g_pll#(
	parameter input_clock_frequency = "322 MHz",
	parameter output_clock_frequency0 = "5.15625 GHz",
	parameter output_clock_frequency1 = "156.25 MHz"
)(
	input  wire        pll_rstn,
	input  wire        pll_ref_clk,         
	output wire        pll_locked,           
	output wire        clkout_totx,       
	output wire        clk33pcs       

);
wire fboutclk0;
wire fboutclk1;
wire pll_locked0;
wire pll_locked1;
assign pll_locked =pll_locked0 |pll_locked1; 


	generic_pll #(
		.reference_clock_frequency(input_clock_frequency),
		.output_clock_frequency(output_clock_frequency0)
	) altera_pll_0 (
		.outclk	(clkout_totx),
		.fboutclk	(fboutclk0),
		.rst	(pll_rstn),
		.refclk	(pll_ref_clk),
		.fbclk	(fboutclk0),
		.locked	(pll_locked0)
	);
	
	generic_pll #(
		.reference_clock_frequency(input_clock_frequency),
		.output_clock_frequency(output_clock_frequency1)
	) altera_pll_1 (
		.outclk	(clk33pcs),
		.fboutclk	(fboutclk1),
		.rst	(pll_rstn),
		.refclk	(pll_ref_clk),
		.fbclk	(fboutclk1),
		.locked	(pll_locked1)
	);

endmodule

                                                                  